# React.js Koans

If you want to learn React.js you came to the right place. We prepared a set of practical exercises that will help you learn React.js from square one. No previous knowledge is required. The only thing you need to know is JavaScript (of course).

The Koans are a set of tasks to complete. Prepared tests checks if they are done correctly.

## Installation

Make sure you have Node.js and Python 2 installed.

  1. `git clone https://github.com/arkency/reactjs_koans.git`
  2. `cd reactjs_koans`
  3. `npm run setup`

## Koans structure

 * Edit the files found in the **`exercises`** directory.
 * The `koans` directory contains the source of all the exercises. `test` contains the tests.
 * `src` a contains files compiled from `exercises`.
 * `build` contains sources launched in the web browser version of Koans.

## Start a local web server (optional)

You can run a webserver and see your changes live in your web browser:

  1. Run command `npm run start`
  2. Visit http://localhost:8080/

## Instructions

  1. Work on the code found in the `exercises` directory and run the tests to see if you did everything right.
  2. You need to do the exercises in the given order.
  3. Try to not peek at the test files! They contain spoilers.
  4. To run the tests, use `npm run test-es6`. To automatically run tests when your code changes, use `npm run watch`.

## Join our newsletter

Join our [React.js Kung Fu newsletter](http://eepurl.com/br5PF1) and receive free React.js lessons every now and then.

## Story of this project

<img src="http://blog.arkency.com/assets/images/react-for-rails/cover-fit.png" alt="Rails meets React.js" width="33%" style="margin-right: 3em" align="right" />

We first started teaching React with our ebook for Rails developers. However, we found out that learning from book isn't the most suitable way of learning for everyone. Even though we had hands-on example, we decided to cover basics of React using the koans format.

We covered more advanced topics of React in this book. If you're interested in expanding your knowledge this book can be a great fit. It is aimed for Rails developers mostly, but you don't need to know Rails - React and its concepts are the core of this book.

For the price of the ebook, you get:

* 150~ pages of **hands-on examples, basic theorethical background, tips for testing and best practices**;
* 50~ pages of bonus content - **examples of React in action, more advanced topics and interesting worldviews about creating rich frontends**;
* an additonal **repository of code examples** bundled with the book, so you can take examples from the book and fiddle with them;

You can use special **20% discount code: KOANS**.

[Grab your copy today](https://arkency.dpdcart.com/cart/view?referer=http%3A%2F%2Fblog.arkency.com%2Frails-react%2F&product_id=106660-rails-meets-react-js&__dpd_cart=9f8ff667-a25b-4b05-9a9f-d93653ec28b0) or [download a free chapter](http://blog.arkency.com/assets/misc/rails-meets-react/rails-meets-react-sample.pdf)


## Additional resources

  * [React docs](https://facebook.github.io/react/docs/getting-started.html) - it's a great source of in-depth information about React.
  * [Why keys are important in React](http://blog.arkency.com/2014/10/react-dot-js-and-dynamic-children-why-the-keys-are-important/) - great reading explaining the reason for React's keys.
  * [Reactiflux](http://www.reactiflux.com/). User group on Slack. You can meet a lot of people using React there. There's a channel for beginners `needhelp`.

## License

The project is licensed under the free MIT license. You can read more about it in the [LICENSE file](https://github.com/arkency/reactjs_koans/blob/master/LICENSE)

## About

<img src="http://arkency.com/images/arkency.png" alt="Arkency" width="20%" align="left" />

React Koans is funded and maintained by Arkency. Check out our other [open-source projects](https://github.com/arkency).

You can also [hire us](http://arkency.com) or [read our blog](http://blog.arkency.com).
